﻿using UnityEngine;
using System.Collections;

public class CameraBehavior : MonoBehaviour
{
	public GameObject headObject1, tailObject1;
	public GameObject headObject2, tailObject2;
	
	private Camera camera;
	
	// Use this for initialization
	void Start ()
	{
		this.camera = this.GetComponent<Camera> ();
	}
	
	// Update is called once per frame
	void Update ()
	{
		if (WinScreen.instance != null && WinScreen.instance.isPlaying)
			return;

		Vector3 distance = (this.tailObject1.transform.position - this.headObject1.transform.position) / 2f;
		Vector3 anchor = this.headObject1.transform.position + distance;
		
		float size = 2f;
		
		if (this.headObject2 != null && this.tailObject2 != null) {
			Vector3 distance2 = (this.tailObject2.transform.position - this.headObject2.transform.position) / 2f;
			Vector3 anchor2 = this.headObject2.transform.position + distance;
			
			Vector3 distance3 = (anchor2 - anchor) / 2f;
			Vector3 anchor3 = anchor + distance3;
			
			Vector3 inBetween = anchor2 - anchor;
			float yAbs = Mathf.Abs (inBetween.y);
			float xAbs = Mathf.Abs (inBetween.x);
			
			if (yAbs > 2.5f || xAbs > 4f) {
				float size1 = 0f;
				float size2 = 0f;
				if (yAbs > 2.5f) {
					size1 = (yAbs / 2.5f) * 2f;
				} 
				
				if (xAbs > 4f) {
					size2 = (xAbs / 4f) * 2f;
				}
				size = size1 > size2 ? size1 : size2;
			}
			
			this.transform.position = Vector3.Lerp (this.transform.position, anchor3, 0.25f);
		} else {
			this.transform.position = Vector3.Lerp (this.transform.position, anchor, 0.25f);
		}
		
		if (size > this.camera.orthographicSize) {
			this.camera.orthographicSize = Mathf.Lerp (this.camera.orthographicSize, size, 0.25f);
		} else {
			this.camera.orthographicSize = Mathf.Lerp (this.camera.orthographicSize, size, 0.1f);
		}
	}
}
