﻿using UnityEngine;
using System.Collections;

public class SegmentBehavior : MonoBehaviour
{
	public Rigidbody2D rigidbody;
	public BodyGrabBehavior headBehavior, tailBehavior;
	public Transform target;

	public SpriteRenderer circle;
	public SpriteRenderer joint;

	protected Transform tSprite;

	void Update ()
	{
		if (this.rigidbody != null) {
			if (!headBehavior.IsGrabbing && !tailBehavior.IsGrabbing) {
				this.rigidbody.gravityScale = 0.2f;
			} else {
				this.rigidbody.gravityScale = 0f;
			}
		}

		// point segment
		circle.transform.right = target.position - circle.transform.position;
	}

	public void LoadImage (int num)
	{
		string jointAsset = string.Format ("Sprites/cat_body_{0:D2}_joint", num);
		joint.sprite = ResourceTools.Instantiate<Sprite> (jointAsset);

		string circleAsset = string.Format ("Sprites/cat_body_{0:D2}_main", num);
		circle.sprite = ResourceTools.Instantiate<Sprite> (circleAsset);

		circle.transform.localScale = Vector3.one * 60f;
		circle.transform.localPosition = Vector3.zero;
		circle.transform.localPosition = Vector3.zero;

		joint.transform.SetParent (circle.transform);
		joint.transform.localPosition = Vector3.zero;
		joint.transform.localScale = Vector3.one * 3.1f;
		joint.sortingOrder = circle.sortingOrder - 1;
	}
}
