﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class SpawnerBehavior : MonoBehaviour
{
	public GameObject caterpillarPrefab;
	public GameObject cameraPrefab;
	public GameObject CanvasPrefab;

	public void Start ()
	{
		GameObject.Instantiate (CanvasPrefab);
		GameObject camera = GameObject.Instantiate (this.cameraPrefab) as GameObject;
		camera.transform.position = this.transform.position;
		CameraBehavior cameraBehave = camera.GetComponent<CameraBehavior> ();

		List<int> bodyTypes = new List<int> { 1, 2, 3, 4, 5, 6, 7 };

		GameObject cat1 = GameObject.Instantiate (this.caterpillarPrefab) as GameObject;
		cat1.transform.position = this.transform.position + new Vector3 (0f, 1f, 0f);
		CaterpillarBehavior catBehave1 = cat1.GetComponent<CaterpillarBehavior> ();
		catBehave1.caterHead.playerNumber = 0;
		catBehave1.caterTail.playerNumber = 1;
		cameraBehave.headObject1 = catBehave1.caterHead.gameObject;
		cameraBehave.tailObject1 = catBehave1.caterTail.gameObject;

		int segBody = bodyTypes.PopRandom ();
		SegmentBehavior[] segments1 = cat1.GetComponentsInChildren<SegmentBehavior> ();
		for (int i = 0; i < segments1.Length; ++i) {
			segments1 [i].LoadImage (segBody);
		}
		
		GameObject cat2 = GameObject.Instantiate (this.caterpillarPrefab) as GameObject;
		cat2.transform.position = this.transform.position + new Vector3 (-0.5f, 1.5f, 0f);
		CaterpillarBehavior catBehave2 = cat2.GetComponent<CaterpillarBehavior> ();
		catBehave2.caterHead.playerNumber = 2;
		catBehave2.caterTail.playerNumber = 3;
		cameraBehave.headObject2 = catBehave2.caterHead.gameObject;
		cameraBehave.tailObject2 = catBehave2.caterTail.gameObject;

		segBody = bodyTypes.PopRandom ();
		SegmentBehavior[] segments2 = cat2.GetComponentsInChildren<SegmentBehavior> ();
		for (int i = 0; i < segments2.Length; ++i) {
			segments2 [i].LoadImage (segBody);
		}

		SoundManager.instance.StopAll ();
		SoundManager.instance.PlayGameTheme ();
	}
	

}
