﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.SceneManagement;


public class StartScript : MonoBehaviour
{

	public int LevelLoad;
	public int MaxLevel;

	public int LastLeftSelection = 0;
	public int LastRightSelection = 0;
	
	public GameObject Level1Button;
	public GameObject Level2Button;
	public GameObject Level3Button;

	public Transform mainImage;
	private Vector3 origPosition;

	public bool Level1Selected;
	public bool Level2Selected;
	public bool Level3Selected;

	public Color SelectedColor;
	public Color NonSelectedColor;

	private string rightStick;
	private string leftStick;
	private string rightTrigger;
	private string leftTrigger;

	private KeyCode AButton;
	
	// Use this for initialization
	void Start ()
	{
		Level1Selected = true;
		Level2Selected = false;
		Level3Selected = false;

		this.leftStick = "LeftX";
#if UNITY_STANDALONE_OSX
		this.rightStick = "RightX";
		this.rightTrigger = "RightTrigger";
		this.leftTrigger = "LeftTrigger";
		this.AButton = KeyCode.Joystick1Button16;
#else
		this.rightStick = "RightXPC";
		this.rightTrigger = "RightTriggerPC";
		this.leftTrigger = "LeftTriggerPC";
		this.AButton = KeyCode.Joystick1Button0;
#endif

		origPosition = mainImage.localPosition;

		SoundManager.instance.StopAll ();
		SoundManager.instance.PlayMenuTheme ();
	}
	
	// Update is called once per frame
	void Update ()
	{

		if (Input.GetAxis (this.rightStick) == 0) {
			LastRightSelection = 0;
		}
		if (Input.GetAxis (this.leftStick) == 0) {
			LastLeftSelection = 0;
		}


		if (Input.GetKeyUp (KeyCode.LeftArrow)) {
			ShiftSelectedLeft ();
		} else if (Input.GetAxis (this.rightStick) == -1 && LastRightSelection != -1) {
			ShiftSelectedLeft ();
			LastRightSelection = -1;
		} else if (Input.GetAxis (this.leftStick) == -1 && LastLeftSelection != -1) {
			ShiftSelectedLeft ();
			LastLeftSelection = -1;
		}

		if (Input.GetKeyUp (KeyCode.RightArrow)) {
			ShiftSelectedRight ();
		} else if (Input.GetAxis (this.rightStick) == 1 && LastRightSelection != 1) {
			ShiftSelectedRight ();
			LastRightSelection = 1;
		} else if (Input.GetAxis (this.leftStick) == 1 && LastLeftSelection != 1) {
			ShiftSelectedRight ();
			LastLeftSelection = 1;
		}

		CheckColors ();
		if (Input.GetKeyUp (KeyCode.Space) || Input.GetKeyUp (this.AButton)) {
			SelectLevel ();
		}

		mainImage.localPosition = origPosition + (Vector3.up * 3f * ((MathTools.CosineWave (Time.time * 0.5f) * 2f) - 1f));
		mainImage.localRotation = Quaternion.AngleAxis (4f * ((MathTools.CosineWave (Time.time * 0.25f) * 2f) - 1f), Vector3.forward);
	}

	public void SelectLevel ()
	{
		if (Level1Selected == true)
			SceneManager.LoadScene (1);
		if (Level2Selected == true)
			SceneManager.LoadScene (2);	
		if (Level3Selected == true)
			SceneManager.LoadScene (3);
	}

	public void ShiftSelectedRight ()
	{
		if (Level3Selected == true)
			return;
		if (Level2Selected == true) {
			Level2Selected = false;
			Level3Selected = true;
			return;
		}
		if (Level1Selected == true) {
			Level1Selected = false;
			Level2Selected = true;
			return;
		}

	}


	public void ShiftSelectedLeft ()
	{
		if (Level1Selected == true)
			return;
		if (Level2Selected == true) {
			Level1Selected = true;
			Level2Selected = false;
			return;
		}
		if (Level3Selected == true) {
			Level2Selected = true;
			Level3Selected = false;
			return;
		}
	}

	public void CheckColors ()
	{
		Level1Button.GetComponent<Image> ().color = NonSelectedColor;
		Level2Button.GetComponent<Image> ().color = NonSelectedColor;
		Level3Button.GetComponent<Image> ().color = NonSelectedColor;

		if (Level1Selected) {
			Level1Button.GetComponent<Image> ().color = SelectedColor;
		}
		if (Level2Selected) {
			Level2Button.GetComponent<Image> ().color = SelectedColor;
		}
		if (Level3Selected) {
			Level3Button.GetComponent<Image> ().color = SelectedColor;
		}
	}
}
